{$APPTYPE CONSOLE}
uses
  SysUtils;
var
  ewords: array of String;
  topics, phrase_topics: array of Integer;

procedure GetTopic(w: String);
var
  i: Integer;
begin
  w := UpperCase(w);
  for i := 0 to High(ewords) do
    if ewords[i] = w then
      Inc(phrase_topics[topics[i]]);
end;

const
  T = 10000;
var
  fin, fout: TextFile;
  i, j, k, pm, N, P, word_len: Integer;
  s, cur_word: String;
begin
  AssignFile(fin, 'input.txt'); Reset(fin);
  Readln(fin, N, P);
  SetLength(ewords, N);
  SetLength(topics, N);
  SetLength(phrase_topics, T + 1);
  for i := 0 to N - 1 do begin
    Readln(fin, s);
    j := Pos(' ', s);
    ewords[i] := UpperCase(Copy(s, 1, j - 1));
    //Writeln(ewords[i], '#');
    topics[i] := StrToInt(Copy(s, j + 1, Length(s)));
  end;
  AssignFile(fout, 'output.txt'); Rewrite(fout);
  for i := 1 to P do begin
    Readln(fin, s);
    s := s + ' ';
    word_len := 0;
    for j := 0 to High(phrase_topics) do
      phrase_topics[j] := 0;
    for j := 1 to Length(s) do begin
      if s[j] in ['a'..'z', 'A'..'Z'] then
        Inc(word_len)
      else begin
        if word_len > 0 then begin
          cur_word := Copy(s, j - word_len, word_len);
          GetTopic(cur_word);
          //Writeln(UpperCase(cur_word), '#');
          word_len := 0;
        end;
      end;
    end;
    pm := 0; k := 0;
    for j := 1 to High(phrase_topics) do begin
      //Write(' ', phrase_topics[j]);
      if phrase_topics[j] > pm then begin
        pm := phrase_topics[j];
        k := j;
      end else if phrase_topics[j] = pm then
        k := 0;
    end;
    //Writeln;
    Write(fout, k, ' ');
  end;
  CloseFile(fin);
  CloseFile(fout);
end.